import java.io.*;
import java.util.*;

/**
 * Article饹椹륯饹
 * @author	Conflict
 * @version	0.10
 */
public class ArticleManager {
	//	饹ѿ  ////////////////////////////////////////////
	
	/**
	 * إåǡեγĥҡ
	 */
	public static final String HEADFILE_EXT = ".head";
	
	/**
	 * ʸǡեγĥҡ
	 */
	public static final String BODYFILE_EXT = ".body";
	
	/**
	 * HTMLեγĥҡ
	 */
	public static final String HTMLFILE_EXT = ".html";
	
	//	ͣΥ󥹥
	private static ArticleManager instance = null;
	
	//	󥹥ѿ  ///////////////////////////////////////////
	
	//	ǡȥ
	private Map entity = null;
	
	//	ǡ¸ѥ
	private String datastorePath = ".";
	
	//	᥽å  ///////////////////////////////////////////////////
	
	/**
	 * 󥹥ȥ饯
	 */
	public ArticleManager() {
	}
	
	//	setter/getter  ////////////////////////////////////////////////
	
	/**
	 * datastorePathꤹ롣
	 * @param	datastorePath	ǡȥΥѥ'/'դʤ
	 */
	public void setDatastorePath(String datastorePath) {
		this.datastorePath = datastorePath;
	}

	/**
	 * datastorePath getter
	 */
	public String getDatastorePath() {
		return datastorePath;
	}

	//	ӥͥ᥽å  ///////////////////////////////////////////////
	
	/**
	 * SingletonΥ󥹥󥹼
	 * @return	Υ饹ͣΥ󥹥󥹡
	 */
	public static ArticleManager getInstance() {
		if(instance == null) {
			instance = new ArticleManager();
			instance.entity = new HashMap();
		}
		return instance;
	}
	
	/**
	 * ǡȥ餹٤Ƥε󥹥󥹤롣
	 * ®٤δ顢
	 * 󥹥󥹤ˤϡBODYꤵƤʤǽ롣
	 */
	public void load() {
		//	ե
		String art_names[] = (new File(datastorePath)).list();
		if(art_names == null)
			return;									//	եʤ
		
		for(int i = 0; i < art_names.length; i++) {
			if(!art_names[i].endsWith(HEADFILE_EXT))
				continue;
			
			String id = fileNameToId(art_names[i]);
			get(id);
		}
	}
	
	/**
	 * ǡȥ鵭󥹥󥹤롣®٤δ顢
	 * 󥹥󥹤ˤϡBODYꤵƤʤǽ롣
	 * @param	id		åID
	 * @return	󥹥󥹡ĤʤСnull
	 */
	public Article get(String id) {
		Article art = (Article)entity.get(id);
		
		if(art == null) {
			if(!isExisted(id))
				return null;
			
			try {
				String header = readHeaderFromFile(id);
				art = new Article(id);
				art.setHead(header);
				art.parseHeader();
			}
			catch(IOException e) {
				return null;
			}
			entity.put(id, art);
		}
		return art;
	}
	
	/**
	 * ɤ߹ߺѤߤΤ٤Ƥε롣
	 * @return	Collection
	 */
	public Collection getArticles() {
		return entity.values();
	}
	
	/**
	 * ǡȥ鵭BODYͿ줿󥹥󥹤
	 * ꤹ롣ޤǥեȤʸɤ˥ǥɤͤ
	 * ֤
	 * @param	art		
	 * @return	BODYԤnull
	 */
	public String getBody(Article art) {
		String body = art.getBody();
		if(body == null) {
			try {
				body = readBodyFromFile(art.getMessageID());
			}
			catch(IOException e) {
				return null;
			}
			art.setBody(body);
		}
		return art.getDecodedBody();
	}
	
	/**
	 * ǡȥ¸롣
	 * @param	art		
	 */
	public void store(Article art) throws IOException {
		entity.put(art.getMessageID(), art);
		writeToFile(art);
	}
	
	/**
	 * HTML˽񤭽Ф
	 * @param	art		
	 * @param	path	եϤǥ쥯ȥꡣ'/'դʤ
	 */
	public void outToHtml(Article art, String path) throws IOException {
		File f = new File(
				path + "/" + idToFileName(art.getMessageID()) + HTMLFILE_EXT);
		
		if(f.exists()) {						//	Ǥ¸ߤ?
			//	ε򻲾Ȥ뵭Ƥ줿
			if(art.getReferer() == null)
				return;							//	ȵʤ
			
			boolean updated = false;
			long html_timestamp = f.lastModified();
			
			Iterator itr = art.getReferer().iterator();
			while(itr.hasNext()) {
				String id = (String)itr.next();
				Article follow = (Article)entity.get(id);
				if(follow == null)
					continue;
				
				if(follow.getArchiveDate().getTime() > html_timestamp) {
					updated = true;
					break;
				}
			}
			if(!updated)
				return;							//	HTMLϤΤޤ
		}
		
		FileWriter fw = new FileWriter(f);
		fw.write(art.toHtml());
		fw.close();
	}
	
	/**
	 * åIDե̾
	 * @param	id		åID
	 * @return	ե̾
	 */
	public static String idToFileName(String id) {
		String f = java.net.URLEncoder.encode(id);
		f = f.replace('%', '$');
		return f;
	}
	
	/**
	 * ե̾åID
	 * @param	fname		ե̾
	 * @return	åID
	 */
	public static String fileNameToId(String fname) {
		String id = fname;
		if(id.endsWith(HEADFILE_EXT))
			id = id.substring(0, id.length() - HEADFILE_EXT.length());
		id = id.replace('$', '%');
		
		try {
			id = java.net.URLDecoder.decode(id);
		}
		catch(Exception e) {
			System.out.println(
					"ե̾" + fname + "decodeǤޤ" + e);
		};
		return id;
	}
	
	//	᥽å  /////////////////////////////////////////////////
	
	/**
	 * 뵭Υե뤬¸ߤ뤫ɤ
	 * @param	id		åID
	 * @return	¸ߤtrue
	 */
	protected boolean isExisted(String id) {
		File f = new File(
				datastorePath + "/" + idToFileName(id) + HEADFILE_EXT);
		return f.exists();
	}
	
	/**
	 * ե뤫鵭Υإåɤ߹ࡣ
	 * @param	id		åID
	 * @return	ɤ߹إå
	 * @throws	IOException
	 */
	protected String readHeaderFromFile(String id) throws IOException {
		String fname 
				= datastorePath + "/" + idToFileName(id) + HEADFILE_EXT;
		FileReader fr = new FileReader(fname);
		
		StringBuffer sb = new StringBuffer();
		char[] buf = new char[512];
		int len;
		
		while((len = fr.read(buf, 0, 512)) > -1) {
			sb.append(buf, 0, len);
		}
		
		fr.close();
		return sb.toString();
	}
	
	/**
	 * ե뤫鵭BODYɤ߹ࡣ
	 * @param	id		åID
	 * @return	ɤ߹BODY
	 * @throws	IOException
	 */
	protected String readBodyFromFile(String id) throws IOException {
		String fname 
				= datastorePath + "/" + idToFileName(id) + BODYFILE_EXT;
		FileReader fr = new FileReader(fname);
		
		StringBuffer sb = new StringBuffer();
		char[] buf = new char[512];
		int len;
		
		while((len = fr.read(buf, 0, 512)) > -1) {
			sb.append(buf, 0, len);
		}
		fr.close();
		
		return sb.toString();
	}
	
	/**
	 * ե˽񤭽Ф
	 * @param	art		񤭽Ф
	 * @throws	IOException
	 */
	protected void writeToFile(Article art) throws IOException {
		String fname 
				= datastorePath + "/" + idToFileName(art.getMessageID());
		
		FileWriter fw = new FileWriter(fname + HEADFILE_EXT);
		fw.write(art.getHead());
		fw.close();
		
		fw = new FileWriter(fname + BODYFILE_EXT);
		fw.write(art.getBody());
		fw.close();
	}
}
